<template>
  <el-main>
    <el-row>
      <el-col :span="12">
        <label>input</label>
      </el-col>
      <el-col :span="6">
        <label>mapping</label>
      </el-col>
      <el-col :span="6">
        <el-select v-model="input_type">
          <el-option value="csv"  label="CSV"></el-option>
          <el-option value="tsv"  label="TSV"></el-option>
          <el-option value="json" label="JSON"></el-option>
        </el-select>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <el-input type="textarea" placeholder="Fish love plankton and shrimp." :rows="10" v-model="input"></el-input>
      </el-col>
      <el-col :span="12">
        <el-input type="textarea" placeholder='Fish	Humans
plankton	dogs
shrimp	cats' :rows="10" v-model="mapping"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="11">
        <el-button @click="convert" type="primary" round>実行！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <label>output</label>
      </el-col>
      <el-col :span="24">
        <el-input type="textarea" placeholder="Humans love dogs and cats" :rows="10" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>
</template>

<script>
import _ from 'lodash'

export default {
  data() {
    return {
      mapping: "",
      input: "",
      input_type: "tsv",
      output: "",
    }
  },
  methods: {
    convert() {
      let retVal = this.input
      let mapping = {}

      if (this.input_type === "tsv" || this.input_type === "csv") {
        const lines = this.mapping.split("\n")
        const delimiter = this.input_type == "tsv"? "\t" : ","

        _.forEach(lines, (line) => {
          const kv = line.split(delimiter)
          if (kv.length !== 2) {
            this.$message({
              showClose: true,
              message: "マッピングは要素が2つ(置換前, 置換後)である必要があります",
              type: "error"
            })
            return
          }

          mapping[kv[0].trim()] = kv[1].trim()
        })
      } else if (this.input_type === "json") {
        try {
          mapping = JSON.parse(this.mapping)

          if (_.isArray(mapping)) {
            throw Error("JSONがオブジェクトになっていません")
          }
        } catch(e) {
          this.$message({
            showClose: true,
            message: e.message,
            type: "error"
          })
          return {}
        }
      }

      _.forEach(mapping, (val, key) => {
        retVal = retVal.split(key).join(val)
      })

      this.output = retVal
    }
  }
}
</script>
